package org.owasp.csrf.util;

import java.security.SecureRandom;
import java.security.NoSuchAlgorithmException;
import sun.misc.BASE64Encoder;


public final class CryptoUtil
{
	public final static String DEFAULT_PRNG = "SHA1PRNG";
	
	public final static int DEFAULT_TOKEN_LENGTH = 32;
	
	public static String GenerateRandomToken() throws NoSuchAlgorithmException
	{
		return GenerateRandomToken(DEFAULT_PRNG, DEFAULT_TOKEN_LENGTH);
	}
	
	public static String GenerateRandomToken(int len) throws NoSuchAlgorithmException
	{
		return GenerateRandomToken(DEFAULT_PRNG, len);
	}
	
	public static String GenerateRandomToken(String prng, int len) throws NoSuchAlgorithmException
	{
		byte[] bytes = new byte[len];
		SecureRandom sr = SecureRandom.getInstance(prng);
		
		sr.nextBytes(bytes);
		return new BASE64Encoder().encode(bytes);
	}
}
