package org.owasp.csrf.util;

import java.io.IOException;
import java.io.File;
import java.util.Set;
import java.util.HashSet;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.xml.sax.SAXException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public final class PageUtil
{
	public static Set<String> GetCSRFPages(String configFile) throws IOException, ParserConfigurationException, SAXException
	{
		Set<String> pages = new HashSet<String>();
		Document d = GetDocument(configFile);
		Element root = d.getDocumentElement();
		NodeList children = root.getElementsByTagName("Page");
		
		for(int i=0; i<children.getLength(); i++)
		{
			Node n = (Node)children.item(i);
			
			if(n.getNodeType() == Node.ELEMENT_NODE)
			{
				Element e = (Element)n;
				String s = GetValue(e);
				
				pages.add(s);
			}
		}
		
		return pages;
	}
	
	private static String GetValue(Element e)
	{
		String value = null;
		
		if(e != null)
		{
			Node n = (Node)e.getFirstChild();
			
			if(n != null)
			{
				String s = n.getNodeValue();
				
				if(s != null)
				{
					value = s.trim();
				}
			}
		}
		
		return value;
	}
	
	private static Document GetDocument(String s) throws IOException, ParserConfigurationException, SAXException
	{
		return GetDocument(new File(s));
	}
	
	private static Document GetDocument(File f) throws IOException, ParserConfigurationException, SAXException
	{
		DocumentBuilder builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
		
		return builder.parse(f);
	}
}
